

Imports System.Windows.Forms

Namespace UI

    Partial Public Class DeviceDialog
        Inherits Form

        Private m_inputDeviceID As Integer = 0
        Private m_outputDeviceID As Integer = 0

        Public Sub New()
            InitializeComponent()
            If InputDevice.DeviceCount > 0 Then
                For i As Integer = 0 To InputDevice.DeviceCount - 1
                    inputComboBox.Items.Add(InputDevice.GetDeviceCapabilities(i).name)
                Next
                inputComboBox.SelectedIndex = m_inputDeviceID
            End If
            If OutputDevice.DeviceCount > 0 Then
                For i As Integer = 0 To OutputDevice.DeviceCount - 1
                    outputComboBox.Items.Add(OutputDevice.GetDeviceCapabilities(i).name)
                Next
                outputComboBox.SelectedIndex = m_inputDeviceID
            End If
        End Sub

        Protected Overloads Overrides Sub OnShown(ByVal e As EventArgs)
            If InputDevice.DeviceCount > 0 Then
                inputComboBox.SelectedIndex = m_inputDeviceID
            End If
            If OutputDevice.DeviceCount > 0 Then
                outputComboBox.SelectedIndex = m_outputDeviceID
            End If
            MyBase.OnShown(e)
        End Sub

        Private Sub okButton_Click(ByVal sender As Object, ByVal e As EventArgs)
            If InputDevice.DeviceCount > 0 Then
                m_inputDeviceID = inputComboBox.SelectedIndex
            End If
            If OutputDevice.DeviceCount > 0 Then
                m_outputDeviceID = outputComboBox.SelectedIndex
            End If
            DialogResult = DialogResult.OK
        End Sub

        Private Sub ButtonCancel_Click(ByVal sender As Object, ByVal e As EventArgs) Handles ButtonCancel.Click
            DialogResult = DialogResult.Cancel
        End Sub

        Public Property InputDeviceID() As Integer
            Get
                Return m_inputDeviceID
            End Get
            Set(ByVal value As Integer)
                m_inputDeviceID = value
            End Set
        End Property

        Public Property OutputDeviceID() As Integer
            Get
                Return m_outputDeviceID
            End Get
            Set(ByVal value As Integer)
                m_outputDeviceID = value
            End Set
        End Property

    End Class

End Namespace
