

Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Text
Imports System.Windows.Forms

Namespace UI
	Public Partial Class PianoControlDialog
        Inherits Form

		Private m_lowNoteID As Integer
		Private m_highNoteID As Integer

		Public Sub New()
			InitializeComponent()
			UpdateProperties()
		End Sub

		Private Sub UpdateProperties()
            m_lowNoteID = CInt(lowNoteIDNumericUpDown.Value)
			m_highNoteID = CInt(highNoteIDNumericUpDown.Value)
		End Sub

        Private Sub lowNoteIDNumericUpDown_ValueChanged(ByVal sender As Object, ByVal e As EventArgs) Handles lowNoteIDNumericUpDown.ValueChanged
            If lowNoteIDNumericUpDown.Value > highNoteIDNumericUpDown.Value Then
                highNoteIDNumericUpDown.Value = lowNoteIDNumericUpDown.Value
            End If
        End Sub

        Private Sub highNoteIDNumericUpDown_ValueChanged(ByVal sender As Object, ByVal e As EventArgs) Handles highNoteIDNumericUpDown.ValueChanged
            If highNoteIDNumericUpDown.Value < lowNoteIDNumericUpDown.Value Then
                lowNoteIDNumericUpDown.Value = highNoteIDNumericUpDown.Value
            End If
        End Sub

        Private Sub OkButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OkButton.Click
            UpdateProperties()
            Close()
        End Sub

        Private Sub ButtonCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonCancel.Click
            Close()
        End Sub

		Public Property LowNoteID() As Integer
			Get
				Return m_lowNoteID
			End Get
			Set
                If Value < 0 OrElse Value > ShortMessage.DataMaxValue Then
                    Throw New ArgumentOutOfRangeException("LowNoteID", Value, "Low note ID out of range.")
                End If

                m_lowNoteID = Value

                lowNoteIDNumericUpDown.Value = Value

                If m_lowNoteID > m_highNoteID Then
                    m_highNoteID = m_lowNoteID
                    highNoteIDNumericUpDown.Value = m_highNoteID
                End If
            End Set
		End Property

		Public Property HighNoteID() As Integer
			Get
				Return m_highNoteID
			End Get
			Set
                If Value < 0 OrElse Value > ShortMessage.DataMaxValue Then
                    Throw New ArgumentOutOfRangeException("HighNoteID", Value, "High note ID out of range.")
                End If

                m_highNoteID = Value

                highNoteIDNumericUpDown.Value = Value

                If m_highNoteID < m_lowNoteID Then
                    m_lowNoteID = m_highNoteID
                    lowNoteIDNumericUpDown.Value = m_highNoteID
                End If
            End Set
		End Property

    End Class

End Namespace
