

Public MustInherit Class DeviceException
	Inherits ApplicationException

    Public Const MMSYSERR_NOERROR As Integer = 0
    Public Const MMSYSERR_ERROR As Integer = 1          ' unspecified error 
    Public Const MMSYSERR_BADDEVICEID As Integer = 2    ' device ID out of range 
    Public Const MMSYSERR_NOTENABLED As Integer = 3     ' driver failed enable 
    Public Const MMSYSERR_ALLOCATED As Integer = 4      ' device already allocated 
    Public Const MMSYSERR_INVALHANDLE As Integer = 5    ' device handle is invalid 
    Public Const MMSYSERR_NODRIVER As Integer = 6       ' no device driver present 
    Public Const MMSYSERR_NOMEM As Integer = 7          ' memory allocation error 
    Public Const MMSYSERR_NOTSUPPORTED As Integer = 8   ' function isn't supported 
    Public Const MMSYSERR_BADERRNUM As Integer = 9      ' error value out of range 
    Public Const MMSYSERR_INVALFLAG As Integer = 10     ' invalid flag passed 
    Public Const MMSYSERR_INVALPARAM As Integer = 11    ' invalid parameter passed 
    Public Const MMSYSERR_HANDLEBUSY As Integer = 12    ' handle being used simultaneously on another thread (eg callback) 
    Public Const MMSYSERR_INVALIDALIAS As Integer = 13  ' specified alias not found 
    Public Const MMSYSERR_BADDB As Integer = 14         ' bad registry database 
    Public Const MMSYSERR_KEYNOTFOUND As Integer = 15   ' registry key not found 
    Public Const MMSYSERR_READERROR As Integer = 16     ' registry read error 
    Public Const MMSYSERR_WRITEERROR As Integer = 17    ' registry write error 
    Public Const MMSYSERR_DELETEERROR As Integer = 18   ' registry delete error 
    Public Const MMSYSERR_VALNOTFOUND As Integer = 19   ' registry value not found 
    Public Const MMSYSERR_NODRIVERCB As Integer = 20    ' driver does not call DriverCallback 
    Public Const MMSYSERR_LASTERROR As Integer = 20

	Private m_errorCode As Integer

	Public Sub New(errorCode As Integer)
		Me.m_errorCode = errorCode
	End Sub

	Public ReadOnly Property ErrorCode() As Integer
		Get
			Return m_errorCode
		End Get
    End Property

End Class
