

' ------------------------------------------------------------ the base class for all synthesizer components
Public MustInherit Class Component

    Protected Const PI2 As Single = CSng((Math.PI * 2))
    ' -------------------------------------------------------- playback samples per second
    Private sampleRate As SampleRate
    ' -------------------------------------------------------- the name of the synthesizer component
    Private m_name As String = String.Empty

    Protected Sub New(ByVal sampleRate As SampleRate)
        If sampleRate Is Nothing Then
            Throw New ArgumentNullException("sampleRate")
        End If
        Me.sampleRate = sampleRate
    End Sub

    Protected Sub New(ByVal sampleRate As SampleRate, ByVal name As String)
        If sampleRate Is Nothing Then
            Throw New ArgumentNullException("sampleRate")
        End If
        Me.sampleRate = sampleRate
        If Not String.IsNullOrEmpty(name) Then
            Me.m_name = name
        End If
    End Sub

    ' -------------------------------------------------------------------- get the component samplerate
    Protected ReadOnly Property SamplesPerSecond() As Integer
        Get
            Return sampleRate.SamplesPerSecond
        End Get
    End Property

    ' -------------------------------------------------------------------- get the component name
    Public ReadOnly Property Name() As String
        Get
            Return m_name
        End Get
    End Property

End Class
