

Imports System.Collections.Generic

' ---------------------------------------------------------------------- method for creating synthesizer effects

Public Delegate Function EffectFactory(sampleRate As SampleRate, buffer As StereoBuffer) As IEnumerable(Of EffectComponent)


' ---------------------------------------------------------------------- the base class for all effect components
Public MustInherit Class EffectComponent
    Inherits Component

    ' ------------------------------------------------------------------ used for reading input and writing output
    Private m_buffer As StereoBuffer

    Protected Sub New(ByVal sampleRate As SampleRate, ByVal buffer As StereoBuffer)
        MyBase.New(sampleRate)
        If sampleRate Is Nothing Then
            Throw New ArgumentNullException("sampleRate")
        ElseIf buffer Is Nothing Then
            Throw New ArgumentNullException("buffer")
        End If
        Me.m_buffer = buffer
    End Sub

    Protected Sub New(ByVal sampleRate As SampleRate, ByVal buffer As StereoBuffer, ByVal name As String)
        MyBase.New(sampleRate, name)
        If sampleRate Is Nothing Then
            Throw New ArgumentNullException("sampleRate")
        ElseIf buffer Is Nothing Then
            Throw New ArgumentNullException("buffer")
        End If
        Me.m_buffer = buffer
    End Sub


    ' -------------------------------------------------------------------- causes the effect to process its input
    Public MustOverride Sub Process()

    ' -------------------------------------------------------------------- resets the effect.
    Public MustOverride Sub Reset()

    ' -------------------------------------------------------------------- gets the effect's buffer
    '
    Protected ReadOnly Property Buffer() As StereoBuffer
        Get
            Return m_buffer
        End Get
    End Property

End Class
