
' ---------------------------------------------------------------------- monophonic waveform data buffer
Public Class MonoBuffer

    Private buffer As Single()
    Public Event BufferSizeChanged As EventHandler

    Protected Overridable Sub OnBufferSizeChanged(ByVal e As EventArgs)
        RaiseEvent BufferSizeChanged(Me, e)
    End Sub

    Public Sub New(ByVal bufferSize As Integer)
        If bufferSize < 0 Then Throw New ArgumentOutOfRangeException("bufferSize")
        buffer = New Single(bufferSize - 1) {}
    End Sub

    Public Sub Clear()
        Array.Clear(buffer, 0, buffer.Length)
    End Sub

    Public Function GetBuffer() As Single()
        Return buffer
    End Function

    ' ------------------------------------------------------------------ gets or sets the buffer size
    Public Property BufferSize() As Integer
        Get
            Return buffer.Length
        End Get
        Set(ByVal value As Integer)
            If value < 0 Then Throw New ArgumentOutOfRangeException("value")
            If value = buffer.Length Then Return
            buffer = New Single(value - 1) {}
            OnBufferSizeChanged(EventArgs.Empty)
        End Set
    End Property

End Class
